classification
Title: Improve placing of simple query windows.
Type: enhancement Stage: resolved
Components: Tkinter Versions: Python 3.10
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: Nosy List: serhiy.storchaka, terry.reedy
Priority: normal Keywords: patch

Created on 2020-12-19 15:29 by serhiy.storchaka, last changed 2020-12-25 11:48 by serhiy.storchaka. This issue is now closed.

Pull Requests
URL Status Linked Edit
PR 23856 merged serhiy.storchaka, 2020-12-19 15:36
Messages (3)
msg383382 - (view) Author: Serhiy Storchaka (serhiy.storchaka) * (Python committer) Date: 2020-12-19 15:29
Currently simple query windows in Tkinter (such as tkinter.simpledialog.askinteger()) are placed at position 50 pixels right and 50 pixels below of the top left corner of the parent widget (even if it is not visible). If the parent is not specified, the initial position was determined by a windows manager before issue1538878, after issue1538878 it was placed at position 50 pixels right and 50 pixels below the default root widget (even if it is not visible).

Issue42630 restored the pre-issue1538878 behavior, but it is still has many quirks.

The proposed patch makes the placing algorithm similar to native Tk dialogs.

* If parent is specified and mapped, the query widget is centered at the center of parent. Its position and size can be corrected so that it fits in the virtual root window.
* Otherwise it is centered at the center of the screen.
msg383673 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2020-12-24 03:54
I took a look at the somewhat messy popup placement in IDLE.  The query.Query subclasses are centered over their parent.  Some others are over the window but up and to the left.  Maybe they have a custom geometry setting that I should delete.  Search and replace dialogs are at the upper left of the screen.  Bad if window is at the right edge.  Editor SyntaxError boxes, with no placement specified, are centered on the screen.  Centered on the text frame would be much better (as long as it did not cover the error).  Same would be true of most anything else currently centered.

> * If parent is specified and mapped, the query widget is centered at the center of parent.

I am not sure what 'mapped' means.  With patch, SyntaxError continues to  be centered on screen even with editor visible and focused.  Will say more on the PR.

> Its position and size can be corrected so that it fits in the virtual root window.
I don't understand this.  Will check the code.
msg383699 - (view) Author: Serhiy Storchaka (serhiy.storchaka) * (Python committer) Date: 2020-12-24 18:26
New changeset c6c43b28746b0642cc3c49dd8138b896bed3028f by Serhiy Storchaka in branch 'master':
bpo-42685: Improve placing of simple query windows. (GH-23856)
https://github.com/python/cpython/commit/c6c43b28746b0642cc3c49dd8138b896bed3028f
History
Date User Action Args
2020-12-25 11:48:40serhiy.storchakasetstatus: open -> closed
resolution: fixed
stage: patch review -> resolved
2020-12-24 18:26:36serhiy.storchakasetmessages: + msg383699
2020-12-24 03:54:39terry.reedysetnosy: + terry.reedy
messages: + msg383673
2020-12-19 15:36:12serhiy.storchakasetkeywords: + patch
stage: patch review
pull_requests: + pull_request22721
2020-12-19 15:29:47serhiy.storchakacreate